diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
index 66c1488..8669160 100644
--- a/hubs/tests/test_models.py
+++ b/hubs/tests/test_models.py
@@ -32,7 +32,7 @@ class ModelTest(hubs.tests.APPTest):
 
         # check if widgets still are intact
         widgets = hubs.models.Widget.by_hub_id_all(hub.name)
-        self.assertEqual(12, len(widgets))
+        self.assertEqual(13, len(widgets))
 
     def test_delete_hubs(self):
         # verify the hub exists
@@ -48,7 +48,7 @@ class ModelTest(hubs.tests.APPTest):
 
         # check if widgets exist
         widgets = hubs.models.Widget.by_hub_id_all(hub.name)
-        self.assertEqual(12, len(widgets))
+        self.assertEqual(13, len(widgets))
 
         # delete the hub
         self.session.delete(hub)
diff --git a/hubs/widgets/halp/__init__.py b/hubs/widgets/halp/__init__.py
new file mode 100644
index 0000000..92df5a4
--- /dev/null
+++ b/hubs/widgets/halp/__init__.py
@@ -0,0 +1,35 @@
+from __future__ import unicode_literals
+
+
+import arrow
+
+from hubs.widgets.base import Widget
+from hubs.widgets import validators
+
+
+class Halp(Widget):
+
+    name = "halp"
+    label = "Help Requests"
+    position = "both"
+    parameters = [
+        dict(
+            name="hubs",
+            label="Hubs",
+            default=[],
+            validator=validators.CommaSeparatedList,
+            help="A comma-separated list of hubs to monitor.",
+        ), dict(
+            name="per_page",
+            label="Requests per page",
+            default=4,
+            validator=validators.Integer,
+            help="The number of requests per page to display.",
+        )]
+    views_module = ".views"
+    cached_functions_module = ".functions"
+
+    def get_template_environment(self):
+        env = super(Halp, self).get_template_environment()
+        env.filters['humanize'] = lambda d: arrow.get(d).humanize()
+        return env
diff --git a/hubs/widgets/halp/functions.py b/hubs/widgets/halp/functions.py
new file mode 100644
index 0000000..b7f2b88
--- /dev/null
+++ b/hubs/widgets/halp/functions.py
@@ -0,0 +1,149 @@
+from __future__ import unicode_literals
+
+
+import datetime
+import flask
+import fedmsg.meta
+import re
+import logging
+import requests
+import time
+
+from jinja2.utils import urlize
+
+from hubs.widgets.caching import CachedFunction
+
+
+log = logging.getLogger('hubs.widgets')
+
+
+class GetRequests(CachedFunction):
+
+    TOPIC = "org.fedoraproject.prod.meetbot.meeting.item.help"
+
+    def execute(self):
+        # return [_format_message(msg) for msg in EXAMPLE_DATA]
+        from hubs.app import app
+        url = "%s/raw" % app.config["DATAGREPPER_URI"]
+        args = {
+            "topic": self.TOPIC,
+            "delta": str(86400 * 10),  # 10 days
+            # "rows_per_page": per_page,
+        }
+        log.info("Getting request data from Datagrepper")
+        response = requests.get(url, args)
+        if response.status_code != 200:
+            log.warning("Could not get requests from Datagrepper: %s",
+                        response.text)
+            return []
+        raw_messages = response.json()["raw_messages"]
+        return [_format_message(msg) for msg in raw_messages]
+
+    def should_invalidate(self, message):
+        if message["topic"] != self.TOPIC:
+            return False
+        hubs = channel_to_hubs(message['msg']['channel'])
+        return bool(set(hubs) & set(self.instance.config["hubs"]))
+
+
+def channel_to_hubs(channel):
+    # TODO: Link the channel to the hubs that use it.
+    return [channel.lstrip("#")]
+
+
+def _format_message(raw_message):
+    msg = {
+        "date": raw_message["msg"]["details"]["time_"],
+        "channel": raw_message["msg"]["channel"],
+        "hubs": channel_to_hubs(raw_message["msg"]["channel"]),
+        "meeting_topic": raw_message["msg"]["meeting_topic"],
+        "text": raw_message["msg"]["details"]["line"],
+        "context_url": "%s.log.html#l-%s" % (
+            raw_message["msg"]["url"],
+            raw_message["msg"]["details"]["linenum"]),
+        "author": {
+            "name": raw_message["msg"]["details"]["nick"],
+            "avatar": fedmsg.meta.msg2secondary_icon(raw_message["msg"]),
+            "url": flask.url_for(
+                "hub", name=raw_message["msg"]["details"]["nick"]),
+        }
+    }
+    # Extract an URL in the line. Use jinja2's urlize function because the
+    # regexp are better and well-tested.
+    urlized = urlize(raw_message["msg"]["details"]["line"])
+    msg["urls"] = re.findall('<a href="([^"]+)"[^>]*>', urlized)
+    return msg
+
+
+EXAMPLE_DATA = [
+    {
+        "msg": {
+            "details": {
+                "time_": time.mktime((
+                    datetime.datetime.now() - datetime.timedelta(seconds=23)
+                    ).timetuple()),
+                "line": ("The #fedora-apps team needs people to help review "
+                         "code: https://pagure.io/fedora-hubs/issue/21."),
+                "linenum": 42,
+                "nick": "threebean",
+            },
+            "channel": "#fedora-devel",
+            "meeting_topic": "Hubs meeting",
+            "topic": "Hubs meeting",
+            "url": "https://meetbot.fedoraproject.org/fedora-devel/",
+        },
+    },
+    {
+        "msg": {
+            "details": {
+                "time_": time.mktime((
+                    datetime.datetime.now() - datetime.timedelta(hours=2)
+                    ).timetuple()),
+                "line": ("I need help creating signs for Flock: "
+                         "<https://fedorahosted.org/design-team/issue/423> and"
+                         " <https://fedorahosted.org/design-team/issue/424>."),
+                "linenum": 84,
+                "nick": "mizmo",
+            },
+            "channel": "#fedora-design",
+            "meeting_topic": "FLOCK meeting",
+            "topic": "FLOCK meeting",
+            "url": "https://meetbot.fedoraproject.org/fedora-design/",
+        }
+    },
+    {
+        "msg": {
+            "details": {
+                "time_": time.mktime((
+                    datetime.datetime.now() -
+                    datetime.timedelta(days=1, hours=2)
+                    ).timetuple()),
+                "line": ("I need help with the log out bug: "
+                         "https://pagure.io/fedora-hubs/issue/99"),
+                "linenum": 63,
+                "nick": "decause",
+            },
+            "channel": "#fedora-hubs",
+            "meeting_topic": "Hubs meeting",
+            "topic": "Hubs meeting",
+            "url": "https://meetbot.fedoraproject.org/fedora-hubs",
+        }
+    },
+    {
+        "msg": {
+            "details": {
+                "time_": time.mktime((
+                    datetime.datetime.now() -
+                    datetime.timedelta(days=3, hours=20)
+                    ).timetuple()),
+                "line": "Fedora-Hubs should be translated",
+                "linenum": 18,
+                "nick": "mizmo",
+            },
+            "channel": "#fedora-i18n",
+            "meeting_topic": "I18n meeting",
+            "topic": "I18n meeting",
+            "url": "https://meetbot.fedoraproject.org/fedora-hubs",
+        }
+    },
+]
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
new file mode 100644
index 0000000..1aaf1ad
--- /dev/null
+++ b/hubs/widgets/halp/views.py
@@ -0,0 +1,160 @@
+from __future__ import unicode_literals, absolute_import
+
+import datetime
+import flask
+import time
+
+from hubs.widgets.base import WidgetView
+from .functions import GetRequests
+
+
+def paginate(values, per_page):
+    try:
+        total = values.count()
+    except TypeError:
+        total = len(values)
+    try:
+        page = flask.request.values.get("page", 1, int)
+    except ValueError:
+        page = 1
+    last_page = int(total / per_page)
+    if total > last_page * per_page:
+        last_page += 1
+    if last_page < 1:
+        last_page = 1
+    if page < 1:
+        page = 1
+    if page > last_page:
+        page = last_page
+    start = (page - 1) * per_page
+    end = start + per_page
+    page_data = {
+        "nr": page,
+        "has_prev": page > 1,
+        "has_next": page < last_page,
+        "total_entries": total,
+        "total_pages": last_page,
+    }
+    return values[start:end], page_data
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "halp.html"
+
+    def get_context(self, instance, *args, **kwargs):
+        return dict(
+            hubs=instance.config["hubs"],
+            title=self.widget.label,
+            )
+
+
+class DataView(WidgetView):
+
+    name = "data"
+    url_rules = ["data"]
+
+    def dispatch_request(self, *args, **kwargs):
+        """
+        The method that subclasses of :py:class:`flask.views.View` must
+        implement. It binds the other methods together.
+        """
+        instance = self._get_instance(*args, **kwargs)
+        get_requests = GetRequests(instance)
+        data = {"requests": []}
+        hubs_filter = flask.request.args.getlist("hubs")
+        for req in get_requests():
+            req["hub"] = req["hubs"][0]  # Arbitrarily assign the first hub.
+            if "hubs" in flask.request.args:
+                # Find which hubs are targeted by this message.
+                hubs = set(req["hubs"]) & set(hubs_filter)
+                if not hubs:
+                    continue
+                # Arbitrarily assign the first common hub.
+                req["hub"] = list(hubs)[0]
+            data["requests"].append(req)
+            if len(data["requests"]) == 3:
+                # Only 3 requests on the main widget.
+                break
+        return flask.jsonify(data)
+
+
+class SearchView(WidgetView):
+
+    name = "search"
+    url_rules = ["search"]
+    methods = ['GET', 'POST']
+
+    def dispatch_request(self, *args, **kwargs):
+        """
+        The method that subclasses of :py:class:`flask.views.View` must
+        implement. It binds the other methods together.
+        """
+        instance = self._get_instance(*args, **kwargs)
+        get_requests = GetRequests(instance)
+        # prepare filters
+        if "hubs" in flask.request.values:
+            # Find which hubs are targeted by this message.
+            filter_hubs = set(flask.request.values.getlist("hubs"))
+        else:
+            filter_hubs = None
+        filter_people = flask.request.values.get("people")
+        filter_meetingname = flask.request.values.get("meetingname")
+        if flask.request.values.get("startdate"):
+            filter_startdate = datetime.datetime.strptime(
+                flask.request.values.get("startdate"), "%Y-%m-%d")
+            filter_startdate = time.mktime(filter_startdate.timetuple())
+        else:
+            filter_startdate = None
+        if flask.request.values.get("enddate"):
+            filter_enddate = datetime.datetime.strptime(
+                flask.request.values.get("enddate"), "%Y-%m-%d")
+            filter_enddate = time.mktime(filter_enddate.timetuple())
+        else:
+            filter_enddate = None
+
+        # filter the data
+        data = {"requests": []}
+        for req in get_requests():
+            req["hub"] = req["hubs"][0]  # Arbitrarily assign the first hub.
+            if filter_hubs is not None and not set(req["hubs"]) & filter_hubs:
+                continue
+            if filter_people and filter_people not in req["author"]["name"]:
+                continue
+            if (filter_meetingname and
+                    filter_meetingname not in req["meeting_topic"]):
+                continue
+            if filter_startdate is not None and req["date"] < filter_startdate:
+                continue
+            if filter_enddate is not None and req["date"] > filter_enddate:
+                continue
+            data["requests"].append(req)
+        requests, page_data = paginate(
+            data["requests"], instance.config["per_page"])
+        data["requests"] = requests
+        data["page"] = page_data
+        return flask.jsonify(data)
+
+
+class RequestersView(WidgetView):
+
+    name = "requesters"
+    url_rules = ["requesters"]
+    MAX_SUGGESTS = 5
+
+    def dispatch_request(self, *args, **kwargs):
+        """
+        The method that subclasses of :py:class:`flask.views.View` must
+        implement. It binds the other methods together.
+        """
+        instance = self._get_instance(*args, **kwargs)
+        get_requests = GetRequests(instance)
+        results = set([
+            req["author"]["name"] for req in get_requests()
+            if req["author"]["name"].startswith(
+                flask.request.args.get("q"))
+            ])
+        results = sorted(list(results))[:self.MAX_SUGGESTS]
+        return flask.jsonify({"results": results})
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index a037a94..f1dcea7 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -148,3 +148,18 @@ class FedorahostedProject(Validator):
         if response.status_code == 200:
             return value
         raise ValueError('Invalid fedorahosted project')
+
+
+class CommaSeparatedList(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        return [
+            elem.strip() for elem in value.split(",") if elem.strip()
+            ]
+
+    @classmethod
+    def to_string(cls, value):
+        if not value:
+            return ""
+        return ", ".join(value)

